(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('apollo-link'), require('apollo-client'), require('react-apollo'), require('apollo-cache-inmemory'), require('graphql-tools'), require('apollo-link-schema'), require('apollo-link-error'), require('isomorphic-unfetch'), require('apollo-link-http'), require('fs'), require('graphql')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'apollo-link', 'apollo-client', 'react-apollo', 'apollo-cache-inmemory', 'graphql-tools', 'apollo-link-schema', 'apollo-link-error', 'isomorphic-unfetch', 'apollo-link-http', 'fs', 'graphql'], factory) :
  (global = global || self, factory(global['apollo-mocked-provider'] = {}, global.React, global.apolloLink, global.ApolloClient, global.reactApollo, global.apolloCacheInmemory, global.graphqlTools, global.apolloLinkSchema, global.apolloLinkError, global.fetch, global.apolloLinkHttp, global.fs, global.graphql));
}(this, function (exports, React, apolloLink, ApolloClient, reactApollo, apolloCacheInmemory, graphqlTools, apolloLinkSchema, apolloLinkError, fetch, apolloLinkHttp, fs, graphql) { 'use strict';

  ApolloClient = ApolloClient && ApolloClient.hasOwnProperty('default') ? ApolloClient['default'] : ApolloClient;
  fetch = fetch && fetch.hasOwnProperty('default') ? fetch['default'] : fetch;

  var createApolloErrorProvider = function createApolloErrorProvider(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        globalCache = _ref.cache,
        provider = _ref.provider;

    return function (_ref2) {
      var graphQLErrors = _ref2.graphQLErrors,
          cache = _ref2.cache,
          children = _ref2.children;
      // This is just a link that swallows all operations and returns the same thing
      // for every request: The specified error.
      var link = new apolloLink.ApolloLink(function () {
        return new apolloLink.Observable(function (observer) {
          observer.next({
            errors: graphQLErrors || [{
              message: 'Unspecified error from ErrorProvider.'
            }]
          });
          observer.complete();
        });
      });
      var client = new ApolloClient({
        link: link,
        cache: cache || globalCache || new apolloCacheInmemory.InMemoryCache()
      });
      var Provider = provider ? provider : reactApollo.ApolloProvider;
      return React.createElement(Provider, {
        client: client
      }, children);
    };
  };

  var createApolloLoadingProvider = function createApolloLoadingProvider(_temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        globalCache = _ref.cache,
        provider = _ref.provider;

    return function (_ref2) {
      var children = _ref2.children,
          cache = _ref2.cache;
      var link = new apolloLink.ApolloLink(function () {
        return new apolloLink.Observable(function () {});
      });
      var client = new ApolloClient({
        link: link,
        cache: cache || globalCache || new apolloCacheInmemory.InMemoryCache()
      });
      var Provider = provider ? provider : reactApollo.ApolloProvider;
      return React.createElement(Provider, {
        client: client
      }, children);
    };
  };

  var createApolloMockedProvider = function createApolloMockedProvider(typeDefs, _temp) {
    var _ref = _temp === void 0 ? {} : _temp,
        globalCache = _ref.cache,
        provider = _ref.provider,
        links = _ref.links,
        clientResolvers = _ref.clientResolvers;

    return function (_ref2) {
      var _ref2$customResolvers = _ref2.customResolvers,
          customResolvers = _ref2$customResolvers === void 0 ? {} : _ref2$customResolvers,
          componentCache = _ref2.cache,
          children = _ref2.children;
      // const mocks = mergeResolvers(globalMocks, props.customResolvers);
      var schema = graphqlTools.makeExecutableSchema({
        typeDefs: typeDefs,
        resolverValidationOptions: {
          requireResolversForResolveType: false
        }
      });
      graphqlTools.addMockFunctionsToSchema({
        schema: schema,
        mocks: customResolvers
      });
      var cache = componentCache || globalCache || new apolloCacheInmemory.InMemoryCache();
      var customLinks = links ? links({
        cache: cache,
        schema: schema
      }) : [];
      var client = new ApolloClient({
        link: apolloLink.ApolloLink.from([apolloLinkError.onError(function () {})].concat(customLinks, [new apolloLinkSchema.SchemaLink({
          schema: schema
        })])),
        cache: cache,
        defaultOptions: {
          mutate: {
            errorPolicy: 'all'
          }
        },
        resolvers: clientResolvers
      });
      var Provider = provider ? provider : reactApollo.ApolloProvider;
      return React.createElement(Provider, {
        client: client
      }, children);
    };
  };

  var fetchTypeDefs = function fetchTypeDefs(_ref) {
    var _ref$uri = _ref.uri,
        uri = _ref$uri === void 0 ? 'http://localhost:4000/graphql' : _ref$uri,
        _ref$typescript = _ref.typescript,
        typescript = _ref$typescript === void 0 ? true : _ref$typescript,
        _ref$path = _ref.path,
        path = _ref$path === void 0 ? process.cwd() + "/typeDefs." + (typescript ? 'ts' : 'js') : _ref$path;

    try {
      var link = new apolloLinkHttp.HttpLink({
        uri: uri,
        fetch: fetch
      });
      console.log('writing typeDefs to: ', path);
      var _writeFileSync2 = fs.writeFileSync;
      return Promise.resolve(graphqlTools.introspectSchema(link)).then(function (_introspectSchema) {
        _writeFileSync2.call(fs, path, "export const typeDefs = `\n" + graphql.printSchema(_introspectSchema).replace(/`/g, '\\`') + "`");
      });
    } catch (e) {
      return Promise.reject(e);
    }
  };

  exports.createApolloErrorProvider = createApolloErrorProvider;
  exports.createApolloLoadingProvider = createApolloLoadingProvider;
  exports.createApolloMockedProvider = createApolloMockedProvider;
  exports.fetchTypeDefs = fetchTypeDefs;

}));
//# sourceMappingURL=apollo-mocked-provider.umd.development.js.map
